Loading...
Searching...
No Matches
Qore::PipeInputStream Class Reference

This class is not intended to be instantiated directly, please see StreamPipe. More...

`#include <QC_PipeInputStream.dox.h>`

Inheritance diagram for Qore::PipeInputStream:
[legend]

## Public Member Functions

nothing | finishClose ()
| Call when the background operation is finished to wakeup PipeOutputStream::close().
int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available. More...
*binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream. More...
nothing | reportError (hash ex)
| Causes all operations on both pipe streams to wake up and throw an exception. More...
Public Member Functions inherited from Qore::InputStream
| constructor ()
| Constructor. More...
abstract int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available. More...
abstract *binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream. More...
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses. More...
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation. More...
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation. More...

## Protected Member Functions

| constructor ()
| Creates the PipeInputStream.

## Detailed Description

This class is not intended to be instantiated directly, please see StreamPipe.

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

See also
  - StreamReader for a class that can be used to read various kinds of data from an InputStream
  - StreamPipe

Since
  Qore 0.8.13

## Member Function Documentation

## peek()

int Qore::PipeInputStream::peek | ( |  | ) |

virtual

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Implements Qore::InputStream.

## read()

*binary Qore::PipeInputStream::read | ( | int | limit | ) |

virtual

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Exceptions

  INPUT-STREAM-ERROR | limit is not positive

Implements Qore::InputStream.

## reportError()

nothing Qore::PipeInputStream::reportError | ( | hash | ex | ) |

Causes all operations on both pipe streams to wake up and throw an exception.

Normally used from the background thread to report an error to the main thread.

Parameters

  ex | the exception, must contain strings 'err' and 'desc'